#include <windows.h>
#include <algorithm>
#include <iostream>
#include <random>
#include <ppl.h>

using namespace Concurrency;
using namespace std;

// ޹ Լ ȣϰ Լ  ҿ ð ȯ
template <class Function>
__int64 time_call(Function&& f)
{
    __int64 begin = GetTickCount();
    f();
    return GetTickCount() - begin;
}

const bool INCREASING = true;
const bool DECREASING = false;

//     Լ
template <class T>
void compare(T* items, int i, int j, bool dir)
{
    if (dir == (items[i] > items[j]))
    {
        swap(items[i], items[j]);
    }
}

//   ͸ ϴ   Լ( ó)
template <class T>
void bitonic_merge(T* items, int lo, int n, bool dir)
{
    if (n > 1)
    {
        int m = n / 2;
        for (int i = lo; i < lo + m; ++i)
        {
            compare(items, i, i + m, dir);
        }
        bitonic_merge(items, lo, m, dir);
        bitonic_merge(items, lo + m, m, dir);
    }
}

//   ͸ ϴ   Լ( ó)
template <class T>
void bitonic_sort(T* items, int lo, int n, bool dir)
{
    if (n > 1)
    {
        //  ͸   Ʈ Ͽ  ٸ  
        int m = n / 2;
        bitonic_sort(items, lo, m, INCREASING);
        bitonic_sort(items, lo + m, m, DECREASING);

        //  
        bitonic_merge(items,lo, n, dir);
    }
}

//  ͸ ϴ   Լ( ó)
template <class T>
void bitonic_sort(T* items, int size)
{
    bitonic_sort(items, 0, size, INCREASING);
}

//   ͸ ϴ   Լ( ó)
template <class T>
void parallel_bitonic_merge(T* items, int lo, int n, bool dir)
{   
    //  ۾ ִ 쿡  ó
    if (n > 500)
    {
        int m = n / 2;
        for (int i = lo; i < lo + m; ++i)
        {
            compare(items, i, i + m, dir);
        }

        parallel_invoke(
            [&items,lo,m,dir] { parallel_bitonic_merge(items, lo, m, dir); },
            [&items,lo,m,dir] { parallel_bitonic_merge(items, lo + m, m, dir); }
        );
    }
    // ׷    ó
    else if (n > 1)
    {
        bitonic_merge(items, lo, n, dir);
    }   
}

//   ͸ ϴ   Լ( ó)
template <class T>
void parallel_bitonic_sort(T* items, int lo, int n, bool dir)
{   
    if (n > 1)
    {
        //  ͸   Ʈ Ͽ  ٸ  
        int m = n / 2;

        parallel_invoke(
            [&items,lo,m] { parallel_bitonic_sort(items, lo, m, INCREASING); },
            [&items,lo,m] { parallel_bitonic_sort(items, lo + m, m, DECREASING); }
        );

        //  
        parallel_bitonic_merge(items, lo, n, dir);
    }
}

//  ͸ ϴ   Լ( ó)
template <class T>
void parallel_bitonic_sort(T* items, int size)
{
    parallel_bitonic_sort(items, 0, size, INCREASING);
}

int wmain()
{  
    //  2 ŵ 
    const int size = 0x200000;

    // 뷮    
    int* a1 = new int[size];
    int* a2 = new int[size];

    mt19937 gen(42);
    for(int i = 0; i < size; ++i)
    {
        a1[i] = a2[i] = gen();
    }

    __int64 elapsed;

    //  ó    Լ ȣ
    elapsed = time_call([&] { bitonic_sort(a1, size); });
    wcout << L"serial time: " << elapsed << endl;

    //  ó    Լ ȣ
    elapsed = time_call([&] { parallel_bitonic_sort(a2, size); });
    wcout << L"parallel time: " << elapsed << endl;

    delete[] a1;
    delete[] a2;
}